#include "lookup.h"
#include "compare.h"

int lookup( char *x, int xl )
{
    switch ( compare( x, xl, "name" ) ) {
    case LESSER:
      switch ( compare( x, xl, "do" ) ) {
      case LESSER:
        switch ( compare( x, xl, "canceled" ) ) {
        case LESSER:
          switch ( compare( x, xl, "alpha" ) ) {
          case LESSER:
            switch ( compare( x, xl, "a" ) ) {
            case LESSER:
              switch ( compare( x, xl, "*" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O__STAR_ ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "*" ) */
            case EQUAL:  return ( O_A ) ;
            case GREATER:
              switch ( compare( x, xl, "acl" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_ACL ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "acl" ) */
            } /* compare( x, xl, "a" ) */
          case EQUAL:  return ( O_ALPHA ) ;
          case GREATER:
            switch ( compare( x, xl, "binary" ) ) {
            case LESSER:
              switch ( compare( x, xl, "b" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_B ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "b" ) */
            case EQUAL:  return ( O_BINARY ) ;
            case GREATER:
              switch ( compare( x, xl, "c" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_C ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "c" ) */
            } /* compare( x, xl, "binary" ) */
          } /* compare( x, xl, "alpha" ) */
        case EQUAL:  return ( O_CANCELED ) ;
        case GREATER:
          switch ( compare( x, xl, "d" ) ) {
          case LESSER:
            switch ( compare( x, xl, "comment" ) ) {
            case LESSER:
              switch ( compare( x, xl, "cert" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_CERT ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "cert" ) */
            case EQUAL:  return ( O_COMMENT ) ;
            case GREATER:
              switch ( compare( x, xl, "crl" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_CRL ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "crl" ) */
            } /* compare( x, xl, "comment" ) */
          case EQUAL:  return ( O_D ) ;
          case GREATER:
            switch ( compare( x, xl, "delta-crl" ) ) {
            case LESSER:
              switch ( compare( x, xl, "date" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_DATE ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "date" ) */
            case EQUAL:  return ( O_DELTA_CRL ) ;
            case GREATER:
              switch ( compare( x, xl, "display" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_DISPLAY ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "display" ) */
            } /* compare( x, xl, "delta-crl" ) */
          } /* compare( x, xl, "d" ) */
        } /* compare( x, xl, "canceled" ) */
      case EQUAL:  return ( O_DO ) ;
      case GREATER:
        switch ( compare( x, xl, "issuer-info" ) ) {
        case LESSER:
          switch ( compare( x, xl, "g" ) ) {
          case LESSER:
            switch ( compare( x, xl, "e" ) ) {
            case LESSER:
              switch ( compare( x, xl, "dsa-sha1" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_DSA_SHA1 ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "dsa-sha1" ) */
            case EQUAL:  return ( O_E ) ;
            case GREATER:
              switch ( compare( x, xl, "entry" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_ENTRY ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "entry" ) */
            } /* compare( x, xl, "e" ) */
          case EQUAL:  return ( O_G ) ;
          case GREATER:
            switch ( compare( x, xl, "hash" ) ) {
            case LESSER:
              switch ( compare( x, xl, "ge" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_GE ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "ge" ) */
            case EQUAL:  return ( O_HASH ) ;
            case GREATER:
              switch ( compare( x, xl, "issuer" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_ISSUER ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "issuer" ) */
            } /* compare( x, xl, "hash" ) */
          } /* compare( x, xl, "g" ) */
        case EQUAL:  return ( O_ISSUER_INFO ) ;
        case GREATER:
          switch ( compare( x, xl, "le" ) ) {
          case LESSER:
            switch ( compare( x, xl, "keyholder" ) ) {
            case LESSER:
              switch ( compare( x, xl, "k-of-n" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_K_OF_N ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "k-of-n" ) */
            case EQUAL:  return ( O_KEYHOLDER ) ;
            case GREATER:
              switch ( compare( x, xl, "l" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_L ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "l" ) */
            } /* compare( x, xl, "keyholder" ) */
          case EQUAL:  return ( O_LE ) ;
          case GREATER:
            switch ( compare( x, xl, "n" ) ) {
            case LESSER:
              switch ( compare( x, xl, "md5" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_MD5 ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "md5" ) */
            case EQUAL:  return ( O_N ) ;
            case GREATER:
              return (-1) ;   /* undefined */
            } /* compare( x, xl, "n" ) */
          } /* compare( x, xl, "le" ) */
        } /* compare( x, xl, "issuer-info" ) */
      } /* compare( x, xl, "do" ) */
    case EQUAL:  return ( O_NAME ) ;
    case GREATER:
      switch ( compare( x, xl, "reval" ) ) {
      case LESSER:
        switch ( compare( x, xl, "p" ) ) {
        case LESSER:
          switch ( compare( x, xl, "numeric" ) ) {
          case LESSER:
            switch ( compare( x, xl, "not-before" ) ) {
            case LESSER:
              switch ( compare( x, xl, "not-after" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_NOT_AFTER ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "not-after" ) */
            case EQUAL:  return ( O_NOT_BEFORE ) ;
            case GREATER:
              switch ( compare( x, xl, "null" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_NULL ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "null" ) */
            } /* compare( x, xl, "not-before" ) */
          case EQUAL:  return ( O_NUMERIC ) ;
          case GREATER:
            switch ( compare( x, xl, "one-time" ) ) {
            case LESSER:
              switch ( compare( x, xl, "object-hash" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_OBJECT_HASH ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "object-hash" ) */
            case EQUAL:  return ( O_ONE_TIME ) ;
            case GREATER:
              switch ( compare( x, xl, "online" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_ONLINE ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "online" ) */
            } /* compare( x, xl, "one-time" ) */
          } /* compare( x, xl, "numeric" ) */
        case EQUAL:  return ( O_P ) ;
        case GREATER:
          switch ( compare( x, xl, "public-key" ) ) {
          case LESSER:
            switch ( compare( x, xl, "private-key" ) ) {
            case LESSER:
              switch ( compare( x, xl, "prefix" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_PREFIX ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "prefix" ) */
            case EQUAL:  return ( O_PRIVATE_KEY ) ;
            case GREATER:
              switch ( compare( x, xl, "propagate" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_PROPAGATE ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "propagate" ) */
            } /* compare( x, xl, "private-key" ) */
          case EQUAL:  return ( O_PUBLIC_KEY ) ;
          case GREATER:
            switch ( compare( x, xl, "range" ) ) {
            case LESSER:
              switch ( compare( x, xl, "q" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_Q ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "q" ) */
            case EQUAL:  return ( O_RANGE ) ;
            case GREATER:
              return (-1) ;   /* undefined */
            } /* compare( x, xl, "range" ) */
          } /* compare( x, xl, "public-key" ) */
        } /* compare( x, xl, "p" ) */
      case EQUAL:  return ( O_REVAL ) ;
      case GREATER:
        switch ( compare( x, xl, "signature" ) ) {
        case LESSER:
          switch ( compare( x, xl, "rsa-pkcs1-sig" ) ) {
          case LESSER:
            switch ( compare( x, xl, "rsa-pkcs1-md5" ) ) {
            case LESSER:
              switch ( compare( x, xl, "rsa-pkcs1" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_RSA_PKCS1 ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "rsa-pkcs1" ) */
            case EQUAL:  return ( O_RSA_PKCS1_MD5 ) ;
            case GREATER:
              switch ( compare( x, xl, "rsa-pkcs1-sha1" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_RSA_PKCS1_SHA1 ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "rsa-pkcs1-sha1" ) */
            } /* compare( x, xl, "rsa-pkcs1-md5" ) */
          case EQUAL:  return ( O_RSA_PKCS1_SIG ) ;
          case GREATER:
            switch ( compare( x, xl, "set" ) ) {
            case LESSER:
              switch ( compare( x, xl, "sequence" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_SEQUENCE ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "sequence" ) */
            case EQUAL:  return ( O_SET ) ;
            case GREATER:
              switch ( compare( x, xl, "sha1" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_SHA1 ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "sha1" ) */
            } /* compare( x, xl, "set" ) */
          } /* compare( x, xl, "rsa-pkcs1-sig" ) */
        case EQUAL:  return ( O_SIGNATURE ) ;
        case GREATER:
          switch ( compare( x, xl, "time" ) ) {
          case LESSER:
            switch ( compare( x, xl, "subject-info" ) ) {
            case LESSER:
              switch ( compare( x, xl, "subject" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_SUBJECT ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "subject" ) */
            case EQUAL:  return ( O_SUBJECT_INFO ) ;
            case GREATER:
              switch ( compare( x, xl, "tag" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_TAG ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "tag" ) */
            } /* compare( x, xl, "subject-info" ) */
          case EQUAL:  return ( O_TIME ) ;
          case GREATER:
            switch ( compare( x, xl, "version" ) ) {
            case LESSER:
              switch ( compare( x, xl, "uri" ) ) {
              case LESSER:
                return (-1) ;   /* undefined */
              case EQUAL:  return ( O_URI ) ;
              case GREATER:
                return (-1) ;   /* undefined */
              } /* compare( x, xl, "uri" ) */
            case EQUAL:  return ( O_VERSION ) ;
            case GREATER:
              return (-1) ;   /* undefined */
            } /* compare( x, xl, "version" ) */
          } /* compare( x, xl, "time" ) */
        } /* compare( x, xl, "signature" ) */
      } /* compare( x, xl, "reval" ) */
    } /* compare( x, xl, "name" ) */
  return (-1) ;  /* needed by some compilers */
} /* lookup */
